<?php
//full error report - turn off when file is in production
error_reporting(E_ALL);
/*todo: optimize code? error results and empty search queries need work think about how to globalize variables into switch, do author and institution need to be globals?, urlencode search variable and other security stuff
need to create opensearch description file for line 186, figure out better way to grab and print current url
echo '<link href="http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/'.basename(__FILE__).'?'.urlencode($_SERVER['QUERY_STRING']).'" rel="self" type="application/atom+xml" />'."\n";*/

//add title for name of api query
$queryTitle = 'Article, Book and Journal Resources from Montana State University Libraries';

//search query or keyword - default query selects all items in database sorted by date added limited to 10 items/page
if (!isset($_GET['search'])) {
	$search = 'default';
} else {
	$search = $_GET['search'];
}
//sort by date or score (relevance)
if (!isset($_GET['sort'])) {
	$sort = 'score';
} else {
	$sort = $_GET['sort'];
}
//number of results to display
if (!isset($_GET['limit'])) {
	$limit = '10';
} else {
	$limit = $_GET['limit'];
}
//text format of output file - rss, atom, json
if (!isset($_GET['form'])) {
	$form = 'rss';
} else {
	$form = $_GET['form'];
}
/* possible future criteria for dynamic rss
//user name or id
if (!isset($_GET['user'])) {
	$user = 'terraadmin';
} else {
	$user = $_GET['user'];
}
//primary file format of media - flash, itunes, ipod, mp3, flv, m4v
//when switching to dynamic rss query format should be 'itunes' otherwise format is 'm4v'
if (!isset($_GET['media'])) {
	$media = 'itunes ';
} else {
	$media = $_GET['format'];
}
*/

//bring database parameters and functions onto page
include_once 'YOUR DATABASE PARAMETERS HERE';

//retrieve items from database - variables can be passed into query
if ($search == 'default') {
	$query="SELECT resource_id,dc_title,dc_description,UNIX_TIMESTAMP(dc_date) AS date
	FROM resources.resource 
	WHERE resource_status='a'
	GROUP BY resource_id
	ORDER BY date DESC
	LIMIT 0,$limit";
} else {
	$query="SELECT resource_id,dc_title,dc_description,UNIX_TIMESTAMP(dc_date) AS date, 
	MATCH (dc_title) AGAINST ('+$search*' IN BOOLEAN MODE) AS score 
	FROM resources.resource 
	WHERE MATCH (dc_title,dc_description) 
	AGAINST ('+$search*' IN BOOLEAN MODE) AND resource_status='a'
	GROUP BY resource_id
	ORDER BY $sort DESC
	LIMIT 0,$limit";
}
$request = @mysql_query($query,$connectResources);

//get count of total results in database
$getTotal = @mysql_query('SELECT * FROM resources.resource',$connectResources);
$total = mysql_num_rows($getTotal);
 
    //set switch control structure to shift form of resources based on value in url
    switch($form)
    {
        case 'rss':
			global $queryTitle;
			global $total;
			global $limit;
			global $request;
        {
			header('Content-Type:application/rss+xml; charset=utf-8');
			echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
				echo '<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">'."\n";
				echo '<channel>'."\n";
				echo '<title>'.$queryTitle.'</title>'."\n";
				echo '<link>http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/</link>'."\n";
				echo '<atom:link href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'" rel="self" type="application/rss+xml" />'."\n";
				echo '<description>List of recently added library resources (databases, datasets, indexes) from Montana State University. Showing '.$limit.' results out of '.$total.' total results.</description>'."\n";
                echo '<lastBuildDate>'.substr(date("r"),0,-5).date("T").'</lastBuildDate>'."\n";
                echo '<managingEditor>jaclark@montana.edu (Jason Clark)</managingEditor>'."\n";
				echo '<copyright>Copyright '.date("Y").'. Montana State University Libraries</copyright>'."\n";
				//store items in array, strip out html tags, generate valid date stamp
				while($row=mysql_fetch_array($request)) {
					$id=$row['resource_id'];
					$title=stripslashes(strip_tags($row['dc_title']));
					$description=stripslashes(htmlentities(strip_tags(substr($row['dc_description'],0,600))));
					$dateIssued=strftime("%a, %d %b %Y %H:%M:%S MST",$row['date']);
					echo '<item>'."\n";
					echo '<title>'.$title.'</title>'."\n";
					echo '<link>http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'</link>'."\n";
					echo '<description>'.$description.' ...</description>'."\n";
					echo '<guid>http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'</guid>'."\n";
					echo '<pubDate>'.$dateIssued.'</pubDate>'."\n";
					echo '</item>'."\n";
				}
				echo '</channel>'."\n";
				echo '</rss>'."\n";
        }
        break;
        case 'atom':
			global $queryTitle;
			global $total;
			global $limit;
			global $request;
        {
			header('Content-Type:application/xml; charset=utf-8');
			echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
				echo '<feed xmlns="http://www.w3.org/2005/Atom">'."\n";
				echo '<title>'.$queryTitle.'</title>'."\n";
				echo '<subtitle>List of recently added library resources (databases, datasets, indexes) from Montana State University. Showing '.$limit.' results out of '.$total.' total results.</subtitle>'."\n";
				echo '<link href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'" rel="self" type="application/atom+xml" />'."\n";
				echo '<author>'."\n";
				echo '<name>Montana State University Libraries</name>'."\n";
				echo '<email>jaclark@montana.edu</email>'."\n";
				echo '</author>'."\n";
				echo '<id>http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'</id>'."\n";
				echo '<updated>'.date("Y-m-d").'T'.date("H:i:s").'Z</updated>'."\n";
				echo '<rights>Copyright '.date("Y").'. Montana State University Libraries</rights>'."\n";
				//store items in array, strip out html tags, generate valid date stamp
				while($row=mysql_fetch_array($request)) {
					$id=$row['resource_id'];
					$title=stripslashes(strip_tags($row['dc_title']));
					$description=stripslashes(htmlentities(strip_tags(substr($row['dc_description'],0,600))));
					$dateIssued=strftime("%Y-%m-%dT%H:%M:%SZ",$row['date']);
					echo '<entry>'."\n";
					echo '<title>'.$title.'</title>'."\n";
					echo '<link href="http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'" />'."\n";
					echo '<content type="html">'.$description.' ...</content>'."\n";
					echo '<id>http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'</id>'."\n";
					echo '<updated>'.$dateIssued.'</updated>'."\n";
					echo '</entry>'."\n";
				}
				echo '</feed>'."\n";
        }
        break;
        case 'opensearch':
			global $queryTitle;
			global $total;
			global $limit;
			global $search;
			global $request;

   /*<link rel="alternate" href="http://example.com/New+York+History?pw=3" type="text/html"/>
   <link rel="previous" href="http://example.com/New+York+History?pw=2&amp;format=atom" type="application/atom+xml"/>
   <link rel="next" href="http://example.com/New+York+History?pw=4&amp;format=atom" type="application/atom+xml"/>*/	
			
        {
			header('Content-Type:application/xml; charset=utf-8');
			echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
				echo '<feed xmlns="http://www.w3.org/2005/Atom" xmlns:opensearch="http://a9.com/-/spec/opensearch/1.1/">'."\n";
				echo '<title>'.$queryTitle.'</title>'."\n";
				echo '<subtitle>List of recently added library resources (databases, datasets, indexes) from Montana State University. Showing '.$limit.' results out of '.$total.' total results.</subtitle>'."\n";
				echo '<link href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'" rel="self" type="application/atom+xml" />'."\n";
				echo '<author>'."\n";
				echo '<name>Montana State University Libraries</name>'."\n";
				echo '<email>jaclark@montana.edu</email>'."\n";
				echo '</author>'."\n";
				echo '<id>http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'</id>'."\n";
				echo '<updated>'.date("Y-m-d").'T'.date("H:i:s").'Z</updated>'."\n";
				echo '<rights>Copyright '.date("Y").'. Montana State University Libraries</rights>'."\n";
				echo '<opensearch:totalResults>'.$total.'</opensearch:totalResults>'."\n";
				echo '<opensearch:startIndex>1</opensearch:startIndex>'."\n";
				echo '<opensearch:itemsPerPage>'.$limit.'</opensearch:itemsPerPage>'."\n";
				echo '<opensearch:Query role="request" searchTerms="'.$search.'" startPage="1" />'."\n";
				echo '<link rel="self" href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'" type="application/atom+xml"/>'."\n";
				echo '<link rel="first" href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'&amp;limit%3D1" type="application/atom+xml"/>'."\n";
				echo '<link rel="last" href="http://'.urlencode($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'&amp;limit%3D'.$total.'" type="application/atom+xml"/>'."\n";
				echo '<link rel="search" type="application/opensearchdescription+xml" href="http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'resources-opensearch.xml"/>'."\n";
				//store items in array, strip out html tags, generate valid date stamp
				while($row=mysql_fetch_array($request)) {
					$id=$row['resource_id'];
					$title=stripslashes(strip_tags($row['dc_title']));
					$description=stripslashes(htmlentities(strip_tags(substr($row['dc_description'],0,600))));
					$dateIssued=strftime("%Y-%m-%dT%H:%M:%SZ",$row['date']);
					echo '<entry>'."\n";
					echo '<title>'.$title.'</title>'."\n";
					echo '<link href="http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'" />'."\n";
					echo '<content type="html">'.$description.' ...</content>'."\n";
					echo '<id>http://'.$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']).'/about.php?id='.$id.'</id>'."\n";
					echo '<updated>'.$dateIssued.'</updated>'."\n";
					echo '</entry>'."\n";
				}
				echo '</feed>'."\n";
        }
		break;
        case 'json':
			global $queryTitle;
			global $total;
			global $limit;
			global $request;
        {
			header('Content-Type:text/javascript; charset=utf-8');
			echo '{"ResultSet":{'."\n";
			echo '"ResultSetTitle":"'.$queryTitle.'",'."\n";
			echo '"totalResultsAvailable":"'.$total.'",'."\n";
			echo '"totalResultsReturned": "'.$limit.'",'."\n";
			echo '"Result":['."\n";
			while($row = mysql_fetch_array($request)) {
				$id = $row['resource_id'];
				$title = stripslashes(strip_tags($row['dc_title']));
				$description = stripslashes(htmlentities(strip_tags(substr($row['dc_description'],0,600))));
				$link = 'http://'.urlencode($_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF'])).'/about.php%3Fid%3D'.$id.'';
				$dateIssued = strftime("%a, %d %b %Y %H:%M:%S MST",$row['date']);
			//combine variables into json string
			$data.= '{"title":"'.$title.'","link":"'.$link.'","description":"'.$description.'","guid":"'.$id.'","updated":"'.$dateIssued.'"}, ';
 			}
			$data = rtrim($data, ', ');
			echo $data."\n";
 			echo ']'."\n";
			echo '}'."\n";
			echo '}'."\n";
        }
		break;
        case 'sitemap':
			global $limit;
			global $request;
        {
			header('Content-Type:application/xml; charset=utf-8');
			echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
			echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">'."\n";
			while($row=mysql_fetch_array($request)) {
				$id = $row['resource_id'];
				$link = 'http://'.urlencode($_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF'])).'/item.php%3Fid%3D'.$id.'';
				$dateIssued = strftime("%Y-%m-%d",$row['date']);
				echo '<url>'."\n";
				echo '<loc>'.$link.'</loc>'."\n";
				echo '<lastmod>'.$dateIssued.'</lastmod>'."\n";
				echo '<changefreq>weekly</changefreq>'."\n";
				echo '<priority>0.8</priority>'."\n";
				echo '</url>'."\n";
			}
			echo '</urlset>'."\n";
        }
	}
?>